#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#ifdef HAS_NDBM_H
#include <fcntl.h>
#include <ndbm.h>
#endif
#include "directory.h"
#include "xutil.h"
#include "lutil.h"
#include "ftn.h"
#include "config.h"
#include "nodelist.h"
#include "nlindex.h"
#include <csrvthg.h>

node *getnlent(faddr *addr)
{
FILE *fp;
static node nodebuf;
void *a;
static char buf[256],*p,*q;
short rlen;
int j;
int ixflag,stdflag;
#ifdef QDOS
extern int pserve;
#endif

  debug(2,"getnlent for %s",ascfnode(addr,0x1f));
  if(addr == NULL)
     goto retdummy;
#ifdef QDOS
  if(pserve == 0)
  {
    (void)sprintf(buf,"nodelist a %d:%d/%d",addr->zone,addr->net,addr->node);
    a=Request ("pbox", buf, (short)strlen(buf), &rlen);
    (void)strncpy(buf,a,sizeof(buf)-1);
    buf[rlen] = '\0';
    free(a);
   }
#endif
   nodebuf.addr.domain=NULL;
   nodebuf.addr.name=NULL;

   if (addr->zone == 0)
           addr->zone=whoami->addr->zone;
   nodebuf.addr.zone=addr->zone;
   nodebuf.addr.net=addr->net;
   nodebuf.addr.node=addr->node;
   nodebuf.addr.point=addr->point;
   if( pserve != 0)
        goto retdummy;

    p=&buf[0];

    if ((q=strchr(p,','))) *q++='\0';
    nodebuf.type=NL_NONE;
    if (p[0] == '\0') nodebuf.type=NL_NODE;
    else for (j=0;pkey[j].key;j++)
            if (strcasecmp(p,pkey[j].key) == 0)
            {
                    nodebuf.type=pkey[j].type;
                    nodebuf.pflag=pkey[j].pflag;
                    break;
            }
    if (nodebuf.type == NL_NONE)
    {
            for (q=buf;*q;q++) if (*q < ' ') *q='.';
            logerr("nodelist unidentified entry \"%s\"",buf);
            goto retdummy;
    }
    p=q;
    if (p == NULL) goto badsyntax;
    if ((q=strchr(p,','))) *q++='\0';
    p=q;
    if (p == NULL) goto badsyntax;
    if ((q=strchr(p,','))) *q++='\0';
    nodebuf.name=p;
    p=q;
    if (p == NULL) goto badsyntax;
    if ((q=strchr(p,','))) *q++='\0';
    nodebuf.location=p;
    p=q;
    if (p == NULL) goto badsyntax;
    if ((q=strchr(p,','))) *q++='\0';
    nodebuf.sysop=p;
    p=q;
    if (p == NULL) goto badsyntax;
    if ((q=strchr(p,','))) *q++='\0';
    if (strcasecmp(p,"-Unpublished-") == 0)
            nodebuf.phone=NULL;
    else
            nodebuf.phone=p;
    p=q;
    if (p == NULL) goto badsyntax;
    if ((q=strchr(p,','))) *q++='\0';
    nodebuf.speed=atoi(p);
    ixflag=0;
    for (p=q;p;p=q)
    {
            if ((q=strchr(p,','))) *q++='\0';
            stdflag=0;
            for (j=0;fkey[j].key;j++)
                    if (strcasecmp(p,fkey[j].key) == 0)
                    {
                            stdflag=1;
                            nodebuf.flags|=fkey[j].flag;
                    }
            if (!stdflag && (ixflag < MAXUFLAGS))
            {
                    nodebuf.uflags[ixflag++]=p;
                    if (ixflag < MAXUFLAGS) nodebuf.uflags[ixflag]=NULL;
            }
    }
    nodebuf.addr.name=nodebuf.sysop;
    if (addr->domain == NULL) addr->domain=xstrcpy(nodebuf.addr.domain);

    debug(2,"getnlent: type        %d, pflag=%x",nodebuf.type,nodebuf.pflag);
    debug(2,"getnlent: name        %s",nodebuf.name);
    debug(2,"getnlent: location    %s",nodebuf.location);
    debug(2,"getnlent: sysop       %s",nodebuf.sysop);
    debug(2,"getnlent: phone       %s",nodebuf.phone);
    debug(2,"getnlent: speed       %u",nodebuf.speed);
    debug(2,"getnlent: flags       0x%lx",nodebuf.flags);
    for (j=0;nodebuf.uflags[j];j++)
            debug(2,"getnlent: uflag       %s",nodebuf.uflags[j]);

    return &nodebuf;

badsyntax:
        logerr("nodelist bad syntax in line \"%s\"",buf);
        /* fallthrough */
retdummy:
        debug(2,"getnlent returns dummy nodebuff");
        nodebuf.addr.domain=NULL;
        nodebuf.addr.name=NULL;
        nodebuf.addr.zone=0;
        nodebuf.addr.net=0;
        nodebuf.addr.node=0;
        nodebuf.addr.point=0;
        nodebuf.type=0;
        nodebuf.pflag=NL_DUMMY;
        nodebuf.name="Unknown";
        nodebuf.location="Nowhere";
        nodebuf.sysop="Sysop";
        nodebuf.phone=NULL;
        nodebuf.speed=2400;
        nodebuf.flags=0L;
        nodebuf.uflags[0]=NULL;
        
        return &nodebuf;
}
